package org.apache.maven.surefire.util;

/*
 * Copyright 2001-2005 The Codehaus.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import java.io.PrintStream;

/**
 * @author <a href="mailto:jason@maven.org">Jason van Zyl</a>
 * @version $Id: TeeStream.java 353853 2005-12-04 14:52:10Z jvanzyl $
 */
public class TeeStream
    extends PrintStream
{
    PrintStream out;

    public TeeStream( PrintStream out1, PrintStream out2 )
    {
        super( out1 );

        this.out = out2;
    }

    public void write( byte buf[], int off, int len )
    {
        try
        {
            super.write( buf, off, len );

            out.write( buf, off, len );
        }
        catch ( Exception e )
        {
        }
    }

    public void close()
    {
        super.close();

        out.close();
    }

    public void flush()
    {
        super.flush();

        out.flush();
    }
}

